{-
    Copyright 2011 Saurabh Srivastava (saurabhs@cs.umd.edu)

    This file is part of PINS.

    PINS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PINS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PINS.  If not, see <http://www.gnu.org/licenses/>.

-}
module DomLibInvert
where

import Parser

library = [copy, pluse, minuse, updcopy, updint, selpred, updplus, updminus]

{- x -> x -}
copy x = [x]

{- upd(A,x,sel(B,y)) -> upd(B,y,sel(A,x)) -}
updcopy (Expr (Upd arr1 index1 (Sel arr2 index2)))
    = [ Expr (Upd arr2 index2 (Sel arr1 index1)) ]
updcopy x = [x]

{- upd(A,x,j) -> sel(A,x) -}
updint (Expr (Upd arr index (Atom x)))
    = [ Expr (Sel arr index) ] 
updint x = [x]

{- sel(A,x) = _  ->  sel(A,x) -}
selpred (Pred (Eq (Sel arr index) e)) 
    = [ Expr (Sel arr index) ]
selpred x = [x]

{- helps shift.mined -}
{- upd(A,x,e1+e2) -> upd(A,x,e1-e2) -}
updplus (Expr (Upd a x (Plus e1 e2)))
    = [ Expr (Upd a x (Minus e1 e2)) ]
updplus x = [x]

{- helps perm.mined -}
{- upd(A,x,e1-e2) -> upd(A,x,e1+e2) -}
updminus (Expr (Upd a x (Minus e1 e2)))
    = [ Expr (Upd a x (Plus e1 e2)) ]
updminus x = [x]

{- helps rotate -}
{- e1-e2 -> e1+e2 -}
minuse (Expr (Minus e1 e2)) 
    = [ Expr (Plus e1 e2) ]
minuse x = [x]

{- helps rotate -}
{- e1+e2 -> e1-e2 -}
pluse (Expr (Plus e1 e2)) 
    = [ Expr (Minus e1 e2) ]
pluse x = [x]

{- SUBSUMED BY pluse and minuse projectors 
{- x+1 ->  x-1 -}
plusi (Expr (Plus e (Atom (Int i)))) 
    = [ Expr (Minus e (Atom (Int i))) ]
plusi x = [x]

{- x-1 ->  x+1 -}
minusi (Expr (Minus e (Atom (Int i)))) 
    = [ Expr (Plus e (Atom (Int i))) ]
minusi x = [x]
-}

